package wiley.streaming.curator;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.CuratorFrameworkFactory;
import org.apache.curator.framework.recipes.queue.DistributedQueue;
import org.apache.curator.framework.recipes.queue.QueueBuilder;
import org.apache.curator.framework.recipes.queue.QueueConsumer;
import org.apache.curator.framework.state.ConnectionState;
import org.apache.curator.retry.RetryOneTime;

public class DistributedQueueConsumer implements QueueConsumer<WorkUnit> {
	DistributedQueue<WorkUnit> queue;
	String name;
	
	public DistributedQueueConsumer(String connectString,String name) throws Exception {
		this.name = name;
		CuratorFramework client = CuratorFrameworkFactory.newClient(connectString, new RetryOneTime(10));
		client.start();

		queue = QueueBuilder.builder(client, 
				this, 
				new SimpleSerializer<WorkUnit>(), 
				"/queues/work-unit")
		.buildQueue();
		queue.start();
	}

	public void stateChanged(CuratorFramework arg0, ConnectionState arg1) {
		System.out.println(arg1);
	}

	public void consumeMessage(WorkUnit message) throws Exception {
		System.out.println(name+" consumed "+message.workId+"/"+message.payload);
	}
	
}
