package wiley.streaming.curator;

import java.util.Random;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.CuratorFrameworkFactory;
import org.apache.curator.framework.recipes.leader.LeaderSelector;
import org.apache.curator.framework.recipes.leader.LeaderSelectorListener;
import org.apache.curator.framework.state.ConnectionState;
import org.apache.curator.retry.RetryOneTime;

public class UnreliableLeader implements Runnable,LeaderSelectorListener {

	String  name   = "";
	boolean leader = false;
	String  connect;
	Integer lock = new Integer(0);
	
	public UnreliableLeader(String connect,String name) {
		this.connect = connect;
		this.name = name;
	}
	
	
	public void stateChanged(CuratorFramework arg0, ConnectionState arg1) {
		if(arg1 != ConnectionState.CONNECTED) leader = false;
	}

	public void takeLeadership(CuratorFramework client) throws Exception {
		leader = true;
		Random rng = new Random();
		while(leader) {
			if(rng.nextDouble() < 0.30) {
				System.out.println(name+": crashing");
				synchronized(lock) {
					lock.notify();
				}
				return;
			}
			System.out.println(name+": processing event");
			Thread.sleep(rng.nextInt(1000));
		}
		
	}


	public void run() {
		CuratorFramework client = CuratorFrameworkFactory.newClient(connect, new RetryOneTime(10));
		client.start();
		
		System.out.println(name+" is about to start waiting for leadership");
		LeaderSelector selector = new LeaderSelector(client,"/curator_leader",this);
		selector.start();
		synchronized(lock) {
			try {
				lock.wait();
			} catch (InterruptedException e) {
				return;
			}
		}
		
	}

}
