package wiley.streaming.curator;

import static org.junit.Assert.*;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.CuratorFrameworkFactory;
import org.apache.curator.framework.state.ConnectionState;
import org.apache.curator.framework.state.ConnectionStateListener;
import org.apache.curator.retry.ExponentialBackoffRetry;
import org.junit.Before;
import org.junit.Test;

public class ConnectTest {

	@Before
	public void setUp() throws Exception {
	}

	@Test
	public void test() throws InterruptedException {
		CuratorFramework client = CuratorFrameworkFactory.builder()
		  .connectString("localhost:2181")
		  .retryPolicy(new ExponentialBackoffRetry(1000,3))
		  .namespace("subspace")
		.build();
		client.getConnectionStateListenable().addListener(new ConnectionStateListener() {
			public void stateChanged(CuratorFramework arg0, ConnectionState arg1) {
				System.out.println("State Changed: "+arg1);
			}
		});
		client.start();
		Thread.sleep(1000);
	}

}
