package wiley.streaming.curator;

import static org.junit.Assert.*;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.CuratorFrameworkFactory;
import org.apache.curator.framework.state.ConnectionState;
import org.apache.curator.framework.state.ConnectionStateListener;
import org.apache.curator.retry.ExponentialBackoffRetry;
import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.data.Stat;
import org.junit.Before;
import org.junit.Test;

public class ModeTest {

	CuratorFramework client;	
	@Before
	public void setUp() throws Exception {
		client =
				  CuratorFrameworkFactory.builder()
				   .connectString("localhost:2181")
				   .retryPolicy(new ExponentialBackoffRetry(1000,3))
				   .namespace("subspace")
				   .build();
				client.getConnectionStateListenable().addListener(new ConnectionStateListener() {

					public void stateChanged(CuratorFramework arg0, ConnectionState arg1) {
						System.out.println("State Changed: "+arg1);
					}
					
				});
				client.start();		
	}

	@Test
	public void test() throws Exception {
		if(client.checkExists().forPath("/queue") != null)
			client.delete().guaranteed().deletingChildrenIfNeeded().forPath("/queue");
		
		client.create().creatingParentsIfNeeded().forPath("/queue");
		for(int i=0;i<10;i++) {
			System.out.println("Creating children");
			client.create().withMode(CreateMode.PERSISTENT_SEQUENTIAL).forPath("/queue/job");
			Thread.sleep(100);
		}
		Thread.sleep(10000);
	}

}
