package wiley.streaming.flume;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.apache.flume.Channel;
import org.apache.flume.Context;
import org.apache.flume.Event;
import org.apache.flume.channel.AbstractChannelSelector;

public class RandomChannelSelector extends AbstractChannelSelector {

	List<List<Channel>> outputs = new ArrayList<List<Channel>>();
	List<Channel>       empty   = new ArrayList<Channel>();
	Random              rng     = new Random();
	
	public List<Channel> getRequiredChannels(Event event) {
		return outputs.get(rng.nextInt(outputs.size()));
	}

	public List<Channel> getOptionalChannels(Event event) {
		return empty;
	}

	public void configure(Context context) {
		for(Channel c : getAllChannels()) {
			List<Channel> x = new ArrayList<Channel>();
			x.add(c);
			outputs.add(x);
		}
	}

}
