package wiley.streaming.forecast;

public class MultiplicativeForecast extends SeasonalForecast {

	public MultiplicativeForecast(double level, double trend, double a,
			double b, double[] s, double g) {
		super(level, trend, a, b, s, g);
	}
	
	@Override
	public double forecast(double x) {
		int h = (t + (int)Math.floor(x-1.0)) % s.length;
		return super.forecast(x)*s[h];
	}

	@Override
	public double error(double y) {
		return super.error(y)/s[t];
	}

	@Override
	public double update(double y) {
		double z = level() + trend();
		double e = super.update(y)*s[t];
		s[t] = s[t] + (1-a)*g*e/z;
		t = (t + 1) % s.length;
		return e;
	}	
	

	

}
