package wiley.streaming.kafka;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import kafka.consumer.Consumer;
import kafka.consumer.ConsumerConfig;
import kafka.consumer.ConsumerIterator;
import kafka.consumer.KafkaStream;
import kafka.javaapi.consumer.ConsumerConnector;

public class ConsoleConsumer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Properties props = new Properties();
		props.put("zookeeper.connect", "localhost:2181");
		props.put("group.id", "console");
		props.put("zookeeper.session.timeout.ms", "500");
		props.put("zookeeper.sync.timeout.ms", "500");
		props.put("auto.commit.interval.ms", "500");
		ConsumerConfig config = new ConsumerConfig(props);
		
		String topic = args[0];
		HashMap<String,Integer> topicMap = new HashMap<String,Integer>();
		topicMap.put(topic,1);

		ConsumerConnector consumer = Consumer.createJavaConsumerConnector(config);
		Map<String,List<KafkaStream<byte[],byte[]>>> consumerMap = consumer.createMessageStreams(topicMap); 
		KafkaStream<byte[],byte[]> stream = consumerMap.get(topic).get(0);
		
		ConsumerIterator<byte[],byte[]> iter = stream.iterator();
		while(iter.hasNext()) {
			String message = new String(iter.next().message());
			System.out.println(message);
		}
	}

}
