package wiley.streaming.kafka;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Properties;

import kafka.javaapi.producer.Producer;
import kafka.producer.KeyedMessage;
import kafka.producer.ProducerConfig;

public class ConsoleProducer {

	public static void main(String[] args) throws Exception {

		Properties props = new Properties();
		props.put("metadata.broker.list", "localhost:6001,localhost:6002,localhost:6003");
		props.put("serializer.class", "kafka.serializer.StringEncoder");
		props.put("request.required.acks", "1");
		ProducerConfig config = new ProducerConfig(props);
		
		String topic = args[0];
		Producer<String,String> producer = new Producer<String,String>(config);

		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		while(reader.ready()) {
			String toSend = reader.readLine();
			producer.send(new KeyedMessage<String,String>(topic, toSend));
		}
		
	}

}
