package wiley.streaming.ols;

public class SimpleLinearModel {

	public double a,b;
	
	public SimpleLinearModel(double a,double b) {
		this.a = a;
		this.b = b;
	}
	
	public double y(double x) {
		return a + b*x;
	}

	public double error(double[] y,double [] x) {
		double error = 0.0;
		for(int i=0;i<y.length;i++) error += (y[i]-a-b*x[i])*(y[i]-a-b*x[i]);
		return error;
	}

	public void fit(double[] y,double[] x) {
		double sumX = 0.0, sumY = 0.0;
		double sumXY = 0.0, sumX2 = 0.0;
		for(int i=0;i<y.length;i++) {
			sumX += x[i];
			sumY += y[i];
			sumXY += x[i]*y[i];
			sumX2 += x[i]*x[i];
		}
		
		double n = (double)y.length;
		b = (sumXY - (sumX*sumY)/n)/(sumX2 - (sumX*sumX)/n);
		a = sumY/n - (b*sumX)/n;
	}
	
}
