package wiley.streaming.ols;

public class StreamingSimpleLinearModel {

	double sumX = 0.0, sumY = 0.0;
	double sumXY = 0.0, sumX2 = 0.0;
	double n = 0.0;
	
	boolean dirty = true;
	double  a = 0.0,b = 0.0;
	
	private void update() {
		if(!dirty) return;
		b = (sumXY - (sumX*sumY)/n)/(sumX2 - (sumX*sumX)/n);
		a = sumY/n - b*sumX/n;
		dirty = false;
	}
	
	
	public void observe(double y,double x) {
		sumX += x;sumY += y;
		sumXY += x*y;sumX2 += x*x;
		n += 1.0;
		dirty = true;
	}
	
	public double b() { update();return b; }
	public double a() { update();return a; }
}
