package wiley.streaming.outlier;

import wiley.streaming.nn.NeuralNetwork;

public class NeuralNetworkForecaster implements Forecaster {

	NeuralNetwork nn;
	int           n;
	double[]      x;
	double[]      Y = new double[1];
	public NeuralNetworkForecaster(NeuralNetwork nn) {
		this.nn = nn;
	}
	
	public NeuralNetworkForecaster(int n) {
		this(NeuralNetwork.build().inputs(n).layer(n).layer(1));
		this.n = n;
		this.x = new double[n];
	}
	
	public NeuralNetworkForecaster() {
		this(20);
	}
	
	
	public double forecast(double y) {
		if(n > 0) {
			x[x.length - n] = y;
			y = n < x.length ? x[(x.length - n) - 1] : y;
			n--;
			return y;
		} else {
			Y[0]=y;
			y=nn.train(x, Y).output()[0];
			for(int i=0;i<x.length-1;i++)
				x[i]=x[i+1];
			x[x.length-1] = Y[0];
			return y;
		}
	}

}
