package wiley.streaming.ols;

import static org.junit.Assert.*;

import org.apache.commons.math3.stat.regression.MillerUpdatingRegression;
import org.junit.Test;

import wiley.streaming.nn.Layer;
import wiley.streaming.nn.NeuralNetwork;
import ec.util.MersenneTwisterFast;

public class TimeSeriesTest {

	@Test
	public void streamingRegressionTest() {
		int k = 14;
		
		double[] x = new double[k];
		double   y;
		double   t = 0.0;
		MersenneTwisterFast twist = new MersenneTwisterFast();
		MillerUpdatingRegression rm = new MillerUpdatingRegression(k,true);
		for(int i=0;i<1000;i++) {
			double base = Math.sin(t);
			y = base + 0.5*twist.nextGaussian();
			//Update the input time series
			if(i >= x.length) {
				rm.addObservation(x, y);
				if(rm.getN() > 2*x.length) {
					double B[] = rm.regress().getParameterEstimates();
					double y2 = B[0];
					for(int j=0;j<x.length;j++) if(!Double.isNaN(B[j+1])) y2 += B[j+1]*x[j];  
					System.out.println(y2+"\t"+y+"\t"+base);
					//Move the time series over
					for(int j=0;i<x.length-1;j++) x[i] = x[i+1];
					x[x.length-1]=y;
				} else {
					System.out.println(y+"\t"+y+"\t"+base);					
				}
			} else {
				x[i] = y;
			}
			
			
			t += 2.0*Math.PI/60.0;
		}
	}

}
