package wiley.realtime;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

import wiley.realtime.hash.SerializableHasher;

public class HyperLogLog<E extends Serializable> implements Set<E> {
	
	int    m,b;
	double Z;
	double alpha;
	int    V;
	byte[] M;
	
	SerializableHasher hash = new SerializableHasher();
	ObjectOutputStream output;
	
	
	public HyperLogLog(int b) throws IOException {
		output = new ObjectOutputStream(hash);
		this.b = b;
		if(b < 4) b = 4; else if(b > 16) b = 16;
		m = 1 << b;
		M = new byte[m];
		for(int i=0;i<m;i++) M[i] = 0; 
		V = M.length;
		
		switch(b) {
		case 4: alpha = 0.673*m*m;break;
		case 5: alpha = 0.697*m*m;break;
		case 6: alpha = 0.709*m*m;break;
		default: alpha = (0.7212/(1+1.079/m))*m*m;
		}
	}
	
	
	public boolean add(E e) {
		try {
			hash.reset();
			output.writeObject(e);
			int x = hash.hash();
			int j = x >>> (Integer.MAX_VALUE - b);
			x = (x << b)|(1 << (b-1)) + 1;
			int r = Integer.numberOfLeadingZeros(x)+1;
			if(M[j] == 0) {
				V--;
				M[j] = (byte)r;
				return true;
			} else if(r > M[j]) {
				Z -= Math.pow(2, -M[j]);
				Z += Math.pow(2, -r);
				M[j] = (byte)r;
				return true;
			}
			return false;
		} catch(IOException ex) {
			return false;
		}
	}

	public boolean addAll(Collection<? extends E> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public void clear() {
		// TODO Auto-generated method stub
		
	}

	public boolean contains(Object o) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean containsAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	public Iterator<E> iterator() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean remove(Object o) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean removeAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean retainAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return false;
	}

	public int size() {
		double N = alpha/Z;
		if(N <= 5.0*m/2.0 && V > 0) {
			return (int) (m*Math.log((double)m/(double)V));
		} else if(N > Math.pow(2, 32)/30.0){
			return (int) (-Math.pow(2, 32)*Math.log(1.0 - N/Math.pow(2, 32)));
		} else
			return (int)N;
	}
	public double estimateBias(double value) {
		return 0.0;
	}
	public double threshold(int b) {
		return 0.0;
	}
	public int size2() {
		double N = alpha/Z;
		if(N < 5.0*m) N -= estimateBias(N);
		double H = (V > 0) ?  -Math.pow(2, 32)*Math.log(1.0 - N/Math.pow(2, 32)) : N;
		return (int)(H < threshold(b) ? H : N);
	}

	public Object[] toArray() {
		// TODO Auto-generated method stub
		return null;
	}

	public <T> T[] toArray(T[] a) {
		// TODO Auto-generated method stub
		return null;
	}
	
	
	public static double intersection(Set... sets) {
		double estimate = 0;
		for(int k=0;k<sets.length;k++) {
			double sign = Math.pow(-1, k);
			
		}
		
		return estimate;
	}
	
	
}
