package wiley.realtime.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class DyadicInterval {
	public int level = 0;
	public int start = 0;
	
	public DyadicInterval() { }
	public DyadicInterval(int level,int start) { this.level = level;this.start = start; }
	
	public int min() { return (1 << level)*start; }
	public int max() { return (1 << level)*(start+1) - 1; }
	
	public String toString() { return "["+min()+","+max()+"]"; }
	
	public static List<DyadicInterval> createIntervals(int a,int b) {
		ArrayList<DyadicInterval> output = new ArrayList<DyadicInterval>();

		Stack<Integer> left = new Stack<Integer>();
		Stack<Integer> right = new Stack<Integer>();
		left.push(Math.min(a, b));
		right.push(Math.max(a, b)+1);
		
		while(left.size() > 0) {
			int l = left.pop();
			int r = right.pop();
			
			int k = 32;
			for(;k>=0;k--) {
				long J = (1L << k);
				long L = (int)(J*Math.ceil((double)l/(double)J));
				long R = L + J - 1;
				if(R < r) {
					//Segment fits in the range
					output.add(new DyadicInterval((int)k,(int)(L/J)));
					if(L > l) {
						left.push(l);right.push((int)L);
					}
					if(R+1 < r) {
						left.push((int)(R+1));right.push(r);
					}
					break;
				}
			}
		}
		
		
		return output;
	}
	
}
