package wiley.storm.trident;

import backtype.storm.generated.StormTopology;
import backtype.storm.tuple.Fields;
import storm.trident.TridentTopology;
import storm.trident.operation.builtin.Count;
import wiley.storm.TopologyDefinition;
import wiley.storm.util.JSONToTuple;
import wiley.storm.util.PostFilter;

public class WikipediaEditCounter implements TopologyDefinition {

	public StormTopology topology(String[] args) {
		TridentTopology topology = new TridentTopology();
		topology.newStream("edits", SimpleKafkaSpout.spout().configure(args))
			.each(new Fields("value"),JSONToTuple.fn().field("channel", String.class), new Fields("channel"))
			.groupBy(new Fields("channel"))
			.aggregate(new Fields("channel"), new Count(), new Fields("count"))
			.each(new Fields("channel","count"), new PostFilter())
		;
		return topology.build();
	}

}
