package wiley.storm.util;

import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.log4j.Logger;
import org.json.simple.JSONArray;

import storm.trident.operation.BaseFilter;
import storm.trident.tuple.TridentTuple;

public class PostFilter extends BaseFilter {
	private static final Logger LOG = Logger.getLogger(PostFilter.class);
	
	String url = "http://localhost:3000/push";
	
	public PostFilter url(String url) {
		return this;
	}
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 8528535795977667332L;
	transient HttpClient client = null;
	public boolean isKeep(TridentTuple tuple) {
		HttpClient client = new DefaultHttpClient();
		try {
			HttpPost request    = new HttpPost(url);
			String output = JSONArray.toJSONString(tuple);
			LOG.info("Sending: "+output);
			StringEntity params = new StringEntity(output);
			request.addHeader("content-type", "application/json");
			request.setEntity(params);
			client.execute(request);
		} catch(Exception e) {
			LOG.info("Unable to POST: "+e.getMessage());
		} finally {
			client.getConnectionManager().shutdown();
		}
		return true;
	}

}
