

(function() {
  var size = 80;
  var data = [];
  var dur  = 500;

  var margin = {top: 6, right: 0, bottom: 6, left: 40},
        width = 960 - margin.right,
        height = 120 - margin.top - margin.bottom;  

  var svg = d3.select('p#horizon1').append('svg')
  .attr({
    width:margin.left + margin.right + width,
    height:margin.top + margin.bottom + height
  })
  .style("margin-left",-margin.left+"px");
  var g = svg.append("g").attr("transform","translate("+margin.left+","+margin.top+")");
    
  var x = d3.scale.linear().domain([0,size]).range([0,width]);  
  x.axis = d3.svg.axis().scale(x).orient("bottom");

  var axis = g.append("g")
  .attr("class","x axis")
  .attr("transform","translate(0,"+height+")")
  .call(x.axis);
  
  function region(min,max) {
    var y    = d3.scale.linear().domain([min,max]).range([height,0]).clamp(true);
    var area = d3.svg.area()
    .x(function(d,i) { return x(i); })
    .y0(height)
    .y1(function(d,i) { return y(d.y); });
    var path = g.append("g").append("path").data([data]).attr("class","horizon");
    return function() {
      path.attr("d",area);
    }
  }
  
  
  function make(min,max,split) {
    var regions = [];
    var last    = min;
    var incr    = (max-min)/split;
    
    
    for(var i=0;i<split;i++) {
      var to = last+incr;
      regions.push(region(last,to));
      last = to;
    }
    
    return regions;
  }
  var regions = make;
  
  


  var y = d3.scale.linear().domain([0,200/3]).range([height,0]);
  g.append("g")
      .attr("class", "y axis")
      .call(d3.svg.axis().scale(y).ticks(5).orient("left"));  
  
  function update() {
    regions.forEach(function(r) { r(); });
  }
  
  var i = 0;
  $(document).on('data:unsigned',function(event,y) { 
    data.push({x:i,y:y});
    update();    
    if(data.length > size+2) data.shift();
    i++;

  });
  
  
  
  
  
})();